/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.viewers.FieldViewer3D.Views;

import java.awt.Dimension;
import org.visnow.vn.lib.basic.viewers.FieldViewer3D.ViewPanels.ViewPanel;

/**
 * @author Bartosz Borucki (babor@icm.edu.pl)
 * University of Warsaw, Interdisciplinary Centre
 * for Mathematical and Computational Modelling
 */
public class DoubleViewHorizontal extends javax.swing.JPanel
{

    public static final int VIEWPORT_LEFT = 0;
    public static final int VIEWPORT_RIGHT = 1;

    public static final int NO_CHANGE_DIVIDER_ON_RESIZE = 0;
    public static final int CENTER_DIVIDER_ON_RESIZE = 1;
    private int resizeDividerBehaviour = CENTER_DIVIDER_ON_RESIZE;

    /**
     * Creates new form DoubleViewHorizontal
     */
    public DoubleViewHorizontal()
    {
        initComponents();
        splitPane.setDividerLocation(0.5);
    }

    public void reset()
    {
        setViewPanel(VIEWPORT_LEFT, new ViewPanel());
        setViewPanel(VIEWPORT_RIGHT, new ViewPanel());
    }

    public ViewPanel getViewPanel(int n)
    {
        switch (n) {
            case VIEWPORT_LEFT:
                return getLeftViewPanel();
            case VIEWPORT_RIGHT:
                return getRightViewPanel();
            default:
                return null;
        }
    }

    public void setViewPanel(int n, ViewPanel panel)
    {
        int tmp = splitPane.getDividerLocation();
        switch (n) {
            case VIEWPORT_LEFT:
                leftViewPanel.preRemove();
                splitPane.remove(leftViewPanel);
                leftViewPanel.setInUse(false);
                leftViewPanel = panel;
                splitPane.setLeftComponent(leftViewPanel);
                leftViewPanel.setInUse(true);
                leftViewPanel.postAdd();
                break;
            case VIEWPORT_RIGHT:
                rightViewPanel.preRemove();
                splitPane.remove(rightViewPanel);
                rightViewPanel.setInUse(false);
                rightViewPanel = panel;
                splitPane.setRightComponent(rightViewPanel);
                rightViewPanel.setInUse(true);
                rightViewPanel.postAdd();
                break;
        }
        splitPane.setDividerLocation(tmp);
        repaint();
    }

    public ViewPanel getLeftViewPanel()
    {
        return leftViewPanel;
    }

    public Dimension getLeftViewPanelSize()
    {
        return leftViewPanel.getSize();
    }

    public ViewPanel getRightViewPanel()
    {
        return rightViewPanel;
    }

    public Dimension getRightViewPanelSize()
    {
        return rightViewPanel.getSize();
    }

    public int getDividerLocation()
    {
        return splitPane.getDividerLocation();
    }

    public void setDividerLocation(int newLocation)
    {
        splitPane.setDividerLocation(newLocation);
    }

    public void setDividerLocation(double newPercentageLocation)
    {
        splitPane.setDividerLocation(newPercentageLocation);
    }

    public void centerDivider()
    {
        setDividerLocation(0.5);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        splitPane = new javax.swing.JSplitPane();
        leftViewPanel = new org.visnow.vn.lib.basic.viewers.FieldViewer3D.ViewPanels.ViewPanel();
        rightViewPanel = new org.visnow.vn.lib.basic.viewers.FieldViewer3D.ViewPanels.ViewPanel();

        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                formComponentResized(evt);
            }
        });
        setLayout(new java.awt.BorderLayout());

        splitPane.setDividerLocation(300);
        splitPane.setDividerSize(5);
        splitPane.setLeftComponent(leftViewPanel);
        splitPane.setRightComponent(rightViewPanel);

        add(splitPane, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void formComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentResized
        if (resizeDividerBehaviour == CENTER_DIVIDER_ON_RESIZE) {
            centerDivider();
        }
    }//GEN-LAST:event_formComponentResized

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.visnow.vn.lib.basic.viewers.FieldViewer3D.ViewPanels.ViewPanel leftViewPanel;
    private org.visnow.vn.lib.basic.viewers.FieldViewer3D.ViewPanels.ViewPanel rightViewPanel;
    private javax.swing.JSplitPane splitPane;
    // End of variables declaration//GEN-END:variables

}
